import { INestApplication, ValidationPipe } from '@nestjs/common';
import { Test, TestingModule } from '@nestjs/testing';
import { {{Name}}sService } from '../../{{inputName}}s.service';
import request from 'supertest';
// import mocked{{Name}} from './mocks/{{inputName}}.mock';
import mocked{{Name}}s from './mocks/{{inputName}}s.mock.json';
import { {{Name}}Interface } from 'src-server/{{inputName}}s/models/interfaces/{{inputName}}.interface';
import { {{Name}}Model } from 'src-server/{{inputName}}s/models/schemas/{{inputName}}.schema';
import { Create{{Name}}Dto } from 'src-server/{{inputName}}s/dto';
import { Update{{Name}}Dto } from 'src-server/{{inputName}}s/dto';
import { PaginationQueryDto } from 'src-server/common/dto/pagination-query.dto';

describe('{{Name}}s service', () => {
  let {{name}}sService: {{Name}}sService;
  let expectedData: {{Name}}Interface[];
  // let mockedGetThirdData: jest.Mock;

  beforeEach(async () => {
    expectedData = mocked{{Name}}s;

    /*
    const mockedThirdService = {
      getThirdData: jest.fn().mockResolvedValue(mocked{{Name}}s),
      // getThirdData: jest.fn().mockReturnValue(Promise.resolve(mocked{{Name}}s)),
      // getThirdData: jest.fn().mockReturnValue(Promise.reject(mocked{{Name}}s)),
      // getThirdData: mockedGetThirdData
    }
    */

    const moduleFixture: TestingModule = await Test.createTestingModule({
      imports: [
        // CoreModule,
        // ThirdModule,
      ],
      providers: [
        {{Name}}sService,
        /*
        {
            provide: ThirdService,
            useValue: mockedThirdService
        },
        */
      ],
    })
      //.overrideProvider(ThirdService)
      //.useValue(mockedThirdService)
      .compile();
    {{name}}sService = await moduleFixture.get<{{Name}}sService>({{Name}}sService);
  });

  afterEach(() => {
    // To mockRestore the spy
    // You can use mockImplementationOnce() instead of mockImplementation to not having to mockRestore the spy.
    jest.restoreAllMocks();
  });

  // QUERY
  describe('when running a query service', () => {
    const paginationQuery: PaginationQueryDto = {
      limit: 10,
      offset: 1,
      keyword: '',
    };
    describe('and using valid data', () => {
      it('should return a list of data', async () => {
        const mock{{Name}}Model = jest
          .spyOn({{Name}}Model.prototype, 'get')
          .mockImplementationOnce(() => Promise.resolve(expectedData) as any);
        // mockedGetThirdData = jest.fn().mockResolvedValue(expectedData);

        const {{name}}sResult = await {{name}}sService.findAll(paginationQuery);
        expect(mock{{Name}}Model).toBeDefined();
        // expect(mock{{Name}}Model).toHaveBeenCalled();
        expect(mock{{Name}}Model).toBeCalledTimes(1);

        // Check body data
        expect({{name}}sResult).not.toBeNull();
        // expect({{name}}sResult).toEqual(expect.any(Object));
        expect({{name}}sResult).toEqual(expect.any(Array));
        expect({{name}}sResult).toHaveLength(3);
        expect({{name}}sResult).toBe(expectedData);

        // Check also first data
        const first{{Name}} = {{name}}sResult.find(
          ({{name}}: any) => {{name}}.email === 'user@email.com',
        );
        expect(first{{Name}}).toBeTruthy();
        expect(first{{Name}}).toHaveProperty('firstName');
        expect(first{{Name}}.firstName).toBe('John');
        expect(first{{Name}}).toHaveProperty('lastName');
        expect(first{{Name}}.lastName).toBe('Wayne');
      });
      it('should respond with a list of filtered data', async () => {
        // Jest will wait until the done callback is called before finishing the test

        paginationQuery.limit = 2;
        const mock{{Name}}Model = jest
          .spyOn({{Name}}Model.prototype, 'get')
          .mockImplementationOnce(() => Promise.resolve(expectedData) as any);
        const {{name}}sResult = await {{name}}sService.findAll(paginationQuery);

        expect(mock{{Name}}Model).toBeDefined();
        expect(mock{{Name}}Model).toHaveBeenCalled();
        // expect(res.type).toEqual('application/json');
        expect({{name}}sResult).not.toBeNull();
        // expect({{name}}sResult).toEqual(expect.any(Object));
        expect({{name}}sResult).toEqual(expect.any(Array));
        expect({{name}}sResult).toHaveLength(2);
        expect({{name}}sResult).toBe(expectedData);
      });
    });
    describe('and using invalid data', () => {
      it('should throw an error', async () => {
        // Jest will wait until the done callback is called before finishing the test
        const expectedError = { message: 'Error' };
        const mock{{Name}}Model = jest
          .spyOn({{Name}}Model.prototype, 'get')
          .mockImplementationOnce(() => Promise.reject(expectedError) as any);
        // mockedGetThirdData = jest.fn().mockResolvedValue(expectedError);

        expect(mock{{Name}}Model).toBeDefined();
        expect(mock{{Name}}Model).toHaveBeenCalled();
        await expect({{name}}sService.findAll(paginationQuery)).rejects.toThrow();
      });
    });
  });
});
